/*
 * \file estrutura.c
 *
 * \date Feb 27, 2017
 * \author Ting
 */
#include <stdlib.h>
#include "estrutura.h"

void bufCircular_cria (buffer_circular *c, unsigned int n)
{
	c->head = 0;
	c->tail = 0;
	c->num = n;
	if (n == 0)
		c->elementos = NULL;
	else
		c->elementos = (char *)malloc(sizeof(char)*n);
	return;
}

uint8_t bufCircular_insere (buffer_circular *c, char v)
{
}

char bufCircular_remove (buffer_circular *c)
{
}

char bufCircular_ultimo (buffer_circular *c)
{
	if (c->head != c->tail) {
        return(c->elementos[c->tail]);	
	} else {
    	return 0xff;		       ///< invalid value
	}
}

char bufCircular_primeiro (buffer_circular *c)
{
	if (c->head != c->tail) {
		if (c->head == 0) return (c->elementos[c->num-1]);
        return(c->elementos[c->head-1]);	
	} else {
    	return 0xff;		       ///< invalid value
	}
}

uint8_t bufCircular_cheia (buffer_circular *c)
{
}

uint8_t bufCircular_vazia (buffer_circular *c)
{
}

unsigned int bufCircular_tamanho (buffer_circular *c) 
{
     return (c->num);
}

void bufCircular_deleta (buffer_circular *c)
{
     if (c->elementos) 
     	 free((void *)c->elementos);
     c->head = c->tail = c->num =0;
     c->elementos = NULL;
}
